Codeforces Round #361 (Div. 2) B. Mike and Shortcuts

B. Mike and Shortcuts
time limit per test
3 seconds
memory limit per test
256 megabytes
input
standard input
output
standard output

Recently, Mike was very busy with studying for exams and contests. Now he is going to chill a bit by doing some sight seeing in the city.

City consists of n intersections numbered from 1 to n. Mike starts walking from his house located at the intersection number 1 and goes along some sequence of intersections. Walking from intersection number i to intersection j requires |i - j| units of energy. The total energy spent by Mike to visit a sequence of intersections p1 = 1, p2, ..., pk is equal to  units of energy.

Of course, walking would be boring if there were no shortcuts. A shortcut is a special path that allows Mike walking from one intersection to another requiring only 1 unit of energy. There are exactly n shortcuts in Mike's city, the ith of them allows walking from intersection i to intersection ai (i ≤ ai ≤ ai + 1) (but not in the opposite direction), thus there is exactly one shortcut starting at each intersection. Formally, if Mike chooses a sequence p1 = 1, p2, ..., pk then for each 1 ≤ i < k satisfying pi + 1 = api and api ≠ pi Mike will spend only 1 unit of energy instead of |pi - pi + 1| walking from the intersection pi to intersection pi + 1. For example, if Mike chooses a sequencep1 = 1, p2 = ap1, p3 = ap2, ..., pk = apk - 1, he spends exactly k - 1 units of total energy walking around them.

Before going on his adventure, Mike asks you to find the minimum amount of energy required to reach each of the intersections from his home. Formally, for each 1 ≤ i ≤ n Mike is interested in finding minimum possible total energy of some sequence p1 = 1, p2, ..., pk = i.

Input

The first line contains an integer n (1 ≤ n ≤ 200 000) — the number of Mike's city intersection.

The second line contains n integers a1, a2, ..., an (i ≤ ai ≤ n , , describing shortcuts of Mike's city, allowing to walk from intersection i to intersection ai using only 1 unit of energy. Please note that the shortcuts don't allow walking in opposite directions (from ai to i).

Output

In the only line print n integers m1, m2, ..., mn, where mi denotes the least amount of total energy required to walk from intersection 1 to intersection i.

Examples
input
3
2 2 3
output
0 1 2 
input
5
1 2 3 4 5
output
0 1 2 3 4 
input
7
4 4 4 4 7 7 7
output
0 1 2 1 2 3 3 
Note

In the first sample case desired sequences are:

1: 1m1 = 0;

2: 1, 2m2 = 1;

3: 1, 3m3 = |3 - 1| = 2.

In the second sample case the sequence for any intersection 1 < i is always 1, i and mi = |1 - i|.

In the third sample case — consider the following intersection sequences:

1: 1m1 = 0;

2: 1, 2m2 = |2 - 1| = 1;

3: 1, 4, 3m3 = 1 + |4 - 3| = 2;

4: 1, 4m4 = 1;

5: 1, 4, 5m5 = 1 + |4 - 5| = 2;

6: 1, 4, 6m6 = 1 + |4 - 6| = 3;

7: 1, 4, 5, 7m7 = 1 + |4 - 5| + 1 = 3.


题意

接收一个n,代表有n个城市,每个城市都会与其他城市有一条特殊通道,第二行就是给你每个城市与哪个城市连接,通过特殊通道到达只需1min,相邻的城市耗时也是1min,问你从第一个城市到达其他城市的最短时间。

代码

#include <bits/stdc++.h>
using namespace std;
int n;
int z[200005],flag[200005]={0};
queue <int> q;
void bfs(){
    int i;
    while(!q.empty()){
        i=q.front();
        //getchar();
        //cout<<"tou:"<<q.front()<<endl;
        //cout<<"wei:"<<q.back()<<endl;
        if(flag[i-1]==-1&&i-1>0){
            flag[i-1]=flag[i]+1;
            q.push(i-1);
            //cout<<"-1rudui:"<<i-1<<endl;
        }
        if(flag[i+1]==-1&&i+1<=n){
            flag[i+1]=flag[i]+1;
            q.push(i+1);
            //cout<<"+1rudui:"<<i+1<<endl;
            //cout<<"z"<<endl;
        }
        if(flag[z[i]]==-1){
            flag[z[i]]=flag[i]+1;
            q.push(z[i]);
            //cout<<"kuaijierudui:"<<z[i]<<endl;
        }
        //getchar();
        //cout<<"tou:"<<q.front()<<endl;
        //cout<<"wei:"<<q.back()<<endl;
        q.pop();
        //getchar();
        //cout<<"tou:"<<q.front()<<endl;
        //cout<<"wei:"<<q.back()<<endl;
    }
}
int main()
{
    //freopen("cin.txt","r",stdin);
    int a;
    memset(flag,-1,sizeof(flag));
    cin>>n;
    for(a=1;n>=a;a++){
        cin>>z[a];
    }
    q.push(1);
    flag[1]=0;
    bfs();
    for(a=1;n>=a;a++){
        cout<<flag[a]<<" ";
    }
    cout<<endl;
    return 0;
}

第一次用队列,纪念一下奋斗,这道题应该算是最简单的bfs了吧。

猜你喜欢

转载自blog.csdn.net/ontheway0101/article/details/52755321